# Printscan server
## Version 2

This repository contains files used to set up our printscan server on a freshly installed Armbian. Confirmed to work
with Buster.

### Introduction
(see wiki for need and concept explanation)

Version 2 implementation works roughly as follows:
* the Armbian-based device is connected to local network, and an all-in-one printer is connected to it via USB;
* SANE and CUPS services are installed and running on the device;
* CUPS is configured to provide a remote printer to network;
* SANE is configured for local use only (default behaviour);
* An headless X server is activable via [noVNC](https://github.com/novnc/noVNC);
* This X session presents [Simple Scan](https://github.com/GNOME/simple-scan) tool, allowing users to perform scans;
* The resulted document is automatically uploaded to Kloud, in a temporary directory;
* Every night, the directory from previous day is removed from Kloud.

### Files
#### Installation
* `setup.sh` is a script automating the installation and configuration of required software
#### Run
* `novnc.service`, `vnc.socket` and `vnc@.service` manage the headless X session
* `scan.mount` configures a tmpfs at boot where to store scanned documents before they're sent to Kloud
* `scan-to-cloud.{sh,service,path}` trigger and manage the upload to Kloud
* `clean-cloud.{sh,service,timer}` trigger and manage the removal of previous directory from Kloud
